<?php 
 /* 

                                   _JNJ` 
                               .JNMH` 
                              JMMF`       `;. 
                            .NMM)          `MN. 
                            MMM)            (MML 
                           (MMM`             MMML 
                     M  I  D  N  I  G  H  T    C  o  D  E 
                           (NMMF             MHNH 
                            NMML            .MMM 
                             NMML          .NMH 
                              4MMNL       .#F 
                               `4HNNL_   ` 
                                   `"""` 

                          Copyright (C) 2004-2014 
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org> 

    Midnight Code is a registered trademark of Ian Latter. 

    This program is free software; you can redistribute it and/or modify 
    it under the terms of the GNU General Public License as published by 
    the Free Software Foundation, and mirrored at the Midnight Code web 
    site; as at version 2 of the License only. 

    This program is distributed in the hope that it will be useful, 
    but WITHOUT ANY WARRANTY; without even the implied warranty of 
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
    General Public License for more details. 

    You should have received a copy of the GNU General Public License 
    (version 2) along with this program; if not, write to the Free 
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt 

  */ 

  // TGXf Protocol Constants
  $tgxf_control_type = array(); 
  $tgxf_control_type["START"]["value"] = 1; 
  $tgxf_control_type["START"]["FILENAME"]["value"] = 1; 
  $tgxf_control_type["START"]["FILESIZE"]["value"] = 2; 
  $tgxf_control_type["START"]["QRCODE_VERSION"]["value"] = 3; 
  $tgxf_control_type["START"]["QRCODE_FPS"]["value"] = 4; 
  $tgxf_control_type["START"]["QRCODE_BYTES"]["value"] = 5; 
  $tgxf_control_type[1]["name"] = "START"; 
  $tgxf_control_type[1]["sub_type"][1] = "FILENAME"; 
  $tgxf_control_type[1]["sub_type"][2] = "FILESIZE"; 
  $tgxf_control_type[1]["sub_type"][3] = "QRCODE_VERSION"; 
  $tgxf_control_type[1]["sub_type"][4] = "QRCODE_FPS"; 
  $tgxf_control_type[1]["sub_type"][5] = "QRCODE_BYTES"; 
  $tgxf_control_type["STOP"]["value"] = 2; 
  $tgxf_control_type["STOP"]["PAUSE"]["value"] = 1; 
  $tgxf_control_type["STOP"]["COMPLETE"]["value"] = 2; 
  $tgxf_control_type["STOP"]["CANCEL"]["value"] = 3; 
  $tgxf_control_type[2]["name"] = "STOP"; 
  $tgxf_control_type[2]["sub_type"][1] = "PAUSE"; 
  $tgxf_control_type[2]["sub_type"][2] = "COMPLETE"; 
  $tgxf_control_type[2]["sub_type"][3] = "CANCEL"; 
  $tgxf_control_type["STATUS"]["value"] = 3; 
  $tgxf_control_type["STATUS"]["SINCE"]["value"] = 1; 
  $tgxf_control_type[3]["name"] = "STATUS"; 
  $tgxf_control_type[3]["sub_type"][1] = "SINCE";

  // TGXf Session Parameters (TGXf Global Options)
  $tgxf_session_filepath;
  $tgxf_session_file_size = 0;
  $tgxf_session_qrcode_version = 0;
  $tgxf_session_qrcode_fps = 0;
  $tgxf_session_qrcode_bytes = 0;
 
  // Include the supporting libraries;
  //   PHP QRcode: 	http://phpqrcode.sourceforge.net/
  //   Gif Creator: 	https://github.com/Sybio/GifCreator
  include('phpqrcode/qrlib.php'); 
  include('GifCreator.php'); 


  function get_basename_for_file($filepath) { 
     return pathinfo($filepath, PATHINFO_BASENAME); 
  }


  function get_size_for_file($filepath) { 
    return filesize($filepath); 
  }


  function get_crc_for_file($filepath) { 
    $file_content = file_get_contents($filepath); 
    $crc = crc32($file_content); 

    return $crc; 
  } 


  function debug_control_byte($var, $lbl="DEBUG", $num=false) {
    if($num) {
      $b = decbin($var); 
    } else {
      $b = decbin(ord($var)); 
    }
    print(" " . $lbl . ":[" . substr("00000000",0,8 - strlen($b)) . $b . "] "); 
    return;
  }


  function get_control_bit($data) { 
    $control_byte = ord($data[0]); 
    $control_bit = $control_byte & 1; 

    return $control_bit; 
  } 


  function get_control_type($data) { 
    $control_byte = ord($data[0]); 
    $control_type = ($control_byte & 14) >> 1;

    return $control_type; 
  } 


  function pack_control_payload_16bit_number($data) {
    $payload = pack('C2', ($data >> 8) & 0xFF, ($data >> 0) & 0xFF);

    return $payload; 
  } 


  function pack_control_payload_32bit_number($data) {
    $payload = pack('C4',
      ($data >> 24) & 0xFF,
      ($data >> 16) & 0xFF,
      ($data >> 8) & 0xFF,
      ($data >> 0) & 0xFF);

    return $payload; 
  }

 
  function pack_control_payload_string($data) {
    $payload = NULL;
    $string_len = strlen($data);
    if($string_len > 9)
      $string_len = 9;
    for($idx = 0; $idx < 9; $idx++) {
      $payload .= "\0";
    }
    for($idx = 0; $idx < $string_len; $idx++) {
      $payload{$idx} = $data{$idx};
    }

    return $payload; 
  }


  function pack_data_payload_bin($data, $len) {
    $payload = NULL;
    for($idx = 0; $idx < $len; $idx++) {
      $payload .= $data[$idx];
    }

    return $payload; 
  }


  function build_control_frame($control_type, $control_subtype, $data=NULL) { 
    global $tgxf_control_type; 

    // Zero Control Byte 
    $control_byte = 0; 

    // Control Frame, Control Bit = 1 (bit 0); 
    $control_bit = 1; 
    $control_byte = $control_byte | $control_bit; 

    // Control Byte has Control Type (bits 3,2,1) 
    if($control_type < 0 || $control_type >= 7) 
      $control_type = 0; 
    $control_type = $control_type << 1; 
    $control_byte = $control_byte | $control_type; 

    // Control Byte has Sub-Control Type (bits 7,6,5,4) 
    if($control_subtype < 0 || $control_subtype >= 15) 
      $control_subtype = 0; 
    $control_subtype = $control_subtype << 4; 
    $control_byte = $control_byte | $control_subtype; 

    $payload = NULL; 
    switch(($control_type & 14) >> 1) { 
      case $tgxf_control_type["START"]["value"]: 
        switch(($control_subtype & 240) >> 4) { 
         case $tgxf_control_type["START"]["FILENAME"]["value"]:	      // FILENAME 
            $payload = pack_control_payload_string($data);
            break; 
         case $tgxf_control_type["START"]["FILESIZE"]["value"]:	      // FILESIZE 
            $payload = pack_control_payload_16bit_number($data);
            break; 
         case $tgxf_control_type["START"]["QRCODE_VERSION"]["value"]: // QRCODE_VERSION 
            $payload = pack_control_payload_16bit_number($data);
            break; 
         case $tgxf_control_type["START"]["QRCODE_FPS"]["value"]:     // QRCODE_FPS 
            $payload = pack_control_payload_16bit_number($data);
            break; 
         case $tgxf_control_type["START"]["QRCODE_BYTES"]["value"]:   // QRCODE_BYTES 
            $payload = pack_control_payload_16bit_number($data);
            break; 
        } 
        break; 

      case $tgxf_control_type["STOP"]["value"]: 
        switch(($control_subtype & 240) >> 4) { 
         case $tgxf_control_type["STOP"]["PAUSE"]["value"]:           // PAUSE 
            break; 
         case $tgxf_control_type["STOP"]["COMPLETE"]["value"]:	      // COMPLETE 
            $payload = pack_control_payload_32bit_number($data);
            break; 
         case $tgxf_control_type["STOP"]["CANCEL"]["value"]:	      // CANCEL 
            $payload = pack_control_payload_string($data);
            break; 
        }
        break; 

      case $tgxf_control_type["STATUS"]["value"]: 
        switch(($control_subtype & 240) >> 4) { 
         case $tgxf_control_type["STATUS"]["SINCE"]["value"]:	      // SINCE
            $payload = pack_control_payload_32bit_number($data);
            break;
        }
        break; 

      default: 
        break; 
    } 

    // Frame consists of Control Byte and Control Payload 
    $buffer = pack('C', ($control_byte) & 0xFF) . $payload;

    return $buffer; 
  }


  function build_data_frame($counter, $data, $payload_size) { 

    // Zero Control Byte 
    $control_byte = 0; 

    // Data Frame, Control Bit = 0 (bit 0); 
    $control_bit = 0; 
    $control_byte = $control_byte | $control_bit; 

    // Control Byte has incremented counter (bits 4,3,2,1) 
    if($counter < 0 || $counter > 15) 
      $counter = 0; 
    $counter = $counter << 1; 
    $control_byte = $control_byte | $counter; 

    // Frame consists of Control Byte and Data Payload 
    $payload = pack_data_payload_bin($data, $payload_size);
    $buffer = pack('C', ($control_byte) & 0xFF) . $payload;
 
    return $buffer; 
  } 


  function render_frame($data, $qr_ver, $qr_ecc, $qr_scale, $qr_margin,
    $in_ascii=false) { 
    global $tgxf_control_type; 

    // Generate QRCode as an array of 1 and 0 values, from 8bit data 
    $code = new QRcode(); 
    $code->encodeString8bit($data, $qr_ver, $qr_ecc);
    // $code->encodeString($data, $qr_ver, $qr_ecc, QR_MODE_8, false); 
    QRtools::markTime('after_encode'); 
    $frame = QRtools::binarize($code->data); 

    // Define image dimensions as 1:1 to QRCode size 
    $h = count($frame); 
    $w = strlen($frame[0]); 
    $imgW = $w + (2 * $qr_scale * $qr_margin);
    $imgH = $h + (2 * $qr_scale * $qr_margin);

    if($in_ascii) {
    // ASCII Output
      $target_image = "";
      $padding = "    ";
      $double_x = 0;
      switch("squarecolor") {

        case "compressed":
          // 0.5 row + 1 col per bit
          $target_image .= "\n";
          for($y=0; $y<$h; $y+=2) { 
            $target_image .= $padding;
            for($x=0; $x<$w; $x++) { 
              if($frame[$y][$x] == '1') {
                if(!isset($frame[$y+1])) {
                  // Block characters in the IBM850 Character Encoding
                  $target_image .= chr(223);       // 1,0
                } else {
                  if($frame[$y + 1][$x] == '1') {  // 1,1
                    $target_image .= chr(219);
                  } else {                         // 1,0
                    $target_image .= chr(223);
                  }
                }
              } else {
                if(!isset($frame[$y+1])) {
                  $target_image .= " ";            // 0,0
                } else {
                  if($frame[$y + 1][$x] == '1') {  // 0,1
                    $target_image .= chr(220);
                  } else {                         // 0,0
                    $target_image .= " ";
                  }
                }
              }
            }
            $target_image .= "  \n";
          } 
          break;

        case "squarecolor":
          $double_x = 1;
        case "color":
          // 1 row + 1 col per bit
          for($y=0; $y<$h; $y++) { 
            $target_image .= "\033[0;30;47m" . "\n";  // White on Black
            $target_image .= "\033[0;30;47m" . $padding;
            for($x=0; $x<$w; $x++) { 
              if($frame[$y][$x] == '1') { 
                $target_image .= "\033[0;37;0m ";     // Black on White
              } else {
                $target_image .= "\033[0;30;47m ";
              }
              if($double_x)
                $target_image .= " ";
            }
            $target_image .= "\033[0;30;47m" . $padding;
          } 
          break;

        case "simple":
          // 1 row + 1 col per bit
          for($y=0; $y<$h; $y++) { 
            $target_image .= $padding;
            for($x=0; $x<$w; $x++) { 
              if($frame[$y][$x] == '1') { 
                $target_image .= "#";
              } else {
                $target_image .= " ";
              }
            }
            $target_image .= "  \n";
          } 
          break;
      }

    } else {
    // GRAPHIC Output

      // Create GD image resource 
      $base_image = imagecreate($imgW, $imgH); 
      $col[0] = imagecolorallocate($base_image,255,255,255);   // BG, white 
      // Colors for demonstration only
      if(get_control_bit($data)) { 
        switch(get_control_type($data)) {
          case $tgxf_control_type["START"]["value"]: 
            $col[1] = imagecolorallocate($base_image,0,64,0);  // FG, START = Green
            break;
          case $tgxf_control_type["STATUS"]["value"]: 
            $col[1] = imagecolorallocate($base_image,0,0,64);  // FG, STATUS = Blue
            break;
          case $tgxf_control_type["STOP"]["value"]: 
            $col[1] = imagecolorallocate($base_image,64,0,0);  // FG, STOP = Red
            break;
        }
      } else { 
        $col[1] = imagecolorallocate($base_image,0,0,0);       // FG, black for Data 
      } 
      imagefill($base_image, 0, 0, $col[0]); 

      // Mark pixels in GD image per QRCode array 
      for($y=0; $y<$h; $y++) { 
          for($x=0; $x<$w; $x++) { 
              if($frame[$y][$x] == '1') { 
                imagesetpixel($base_image,
                  $x + ($qr_scale * $qr_margin),
                  $y + ($qr_scale * $qr_margin),
                  $col[1]); 
              } 
          } 
      } 

      // Resize the GD image according to the requested image dimensions 
      $target_image = imagecreate($imgW * $qr_scale, $imgH * $qr_scale); 
      imagecopyresized( 
          $target_image, 
          $base_image, 
          0, 0, 0, 0, 
          $imgW * $qr_scale, $imgH * $qr_scale, $imgW, $imgH 
      ); 
      imagedestroy($base_image); 
    }

    // Return the GD image resource of the final (full scale) image 
    return $target_image; 
  } 



  // Main Program Begins Here 
  set_time_limit(600);

  // Get User Options for Encoding 
  //   CLI (text):	php -q script.php ascii <ver> <fps>
  //   CLI (graphic):	php -q script.php graphic <ver> <fps> > TGXf.gif
  //   Web (graphic):	http://<server>/script.php?ver=<ver>&fps=<fps>
  unset($ui_ver); 
  unset($ui_fps); 
  if(php_sapi_name() == "cli") { 
    // error_reporting(E_ALL ^ E_WARNING);
    if($argc == 4) { 
      $ui_txt = $argv[1]; 
      $ui_ver = $argv[2]; 
      $ui_fps = $argv[3]; 
    } 
  } else { 
    if(array_key_exists("ver", $_REQUEST)) { 
      $ui_ver = $_REQUEST["ver"]; 
    } 
    if(array_key_exists("fps", $_REQUEST)) { 
      $ui_fps = $_REQUEST["fps"]; 
    } 
  } 

  // Validate user input or Default it
  if($ui_ver != 1 && $ui_ver != 2 && $ui_ver != 8 && $ui_ver != 15) 
    $ui_ver = 8;                        // 1 (21x21), 2 (25x25), 8 (49x49), 15 (77x77)
  if($ui_fps != 1 && $ui_fps != 2 && $ui_fps != 5 && $ui_fps != 8 && $ui_fps != 10) 
    $ui_fps = 5;                        // 1, 2, 5, 8, 10 
  if($ui_txt != "ascii" && $ui_txt != "graphic")
    $ui_txt = "graphic";

  // $tgxf_session_filepath =  ...
  $tgxf_session_qrcode_version = $ui_ver;
  $tgxf_session_qrcode_fps = $ui_fps;
  $in_ascii = 0;
  if($ui_txt == "ascii")                // Text mode output
    $in_ascii = 1;

  // Static tables 
  $frame_rounding_correction = 4;	// Allow for variable ECC encoding
  $frame_bytes_version[1] = 14 - $frame_rounding_correction;
  $frame_bytes_version[2] = 26 - $frame_rounding_correction;
  $frame_bytes_version[8] = 152 - $frame_rounding_correction; 
  $frame_bytes_version[15] = 412 - $frame_rounding_correction; 

  // Customisable parameters 
  $mode_ecc_level = QR_ECLEVEL_M;	// _L, _M, _Q, _H 
  $mode_pixel_size = 3;                 // Size according to your display
  $mode_margin_size = 1;

  // File names 
  // $tgxf_session_filepath = "./tgxfv2.php"; 
  $tgxf_session_filepath = "./helloworld.txt"; 
  // $tgxf_session_filepath = "test.jpg"; 
  $user_output_file = "TGXf-v" . $tgxf_session_qrcode_version . "-" . 
    $tgxf_session_qrcode_fps . "fps-" . $mode_pixel_size . "px.gif"; 
  $basename = get_basename_for_file($tgxf_session_filepath); 

  // Calculations based on custom parameters 
  $tgxf_session_qrcode_bytes = $frame_bytes_version[$tgxf_session_qrcode_version];
  $read_bytes = $tgxf_session_qrcode_bytes - 1; // Subtract the Control Byte
  $duration = 100 / $tgxf_session_qrcode_fps; 
  $tgxf_session_file_size = get_size_for_file($tgxf_session_filepath); 
  $tgxf_session_total_crc32 = get_crc_for_file($tgxf_session_filepath);

  // Initialisation 
  $output_frames = array(); 
  $output_times = array(); 
  $tgxf_session_frame_count = 0; 


  // TGXf CONTROL -> START -> FILENAME 
  $frame_data = build_control_frame( 
     $tgxf_control_type["START"]["value"], 
     $tgxf_control_type["START"]["FILENAME"]["value"], 
     $basename);
  $image_data = render_frame($frame_data, $tgxf_session_qrcode_version, 
    $mode_ecc_level, $mode_pixel_size, $mode_margin_size, $in_ascii); 
  $output_frames[] = $image_data; 
  $output_times[] = $duration; 
  // First frame seems to get lost in GifCreator
  $output_frames[] = $image_data; 
  $output_times[] = $duration; 

  // TGXf CONTROL -> START -> FILESIZE 
  $frame_data = build_control_frame( 
     $tgxf_control_type["START"]["value"], 
     $tgxf_control_type["START"]["FILESIZE"]["value"], 
     $tgxf_session_file_size); 
  $image_data = render_frame($frame_data, $tgxf_session_qrcode_version, 
    $mode_ecc_level, $mode_pixel_size, $mode_margin_size, $in_ascii); 
  $output_frames[] = $image_data; 
  $output_times[] = $duration; 

  // TGXf CONTROL -> START -> QRCODE_BYTES 
  $frame_data = build_control_frame( 
     $tgxf_control_type["START"]["value"], 
     $tgxf_control_type["START"]["QRCODE_BYTES"]["value"], 
     $read_bytes); 
  $image_data = render_frame($frame_data, $tgxf_session_qrcode_version, 
    $mode_ecc_level, $mode_pixel_size, $mode_margin_size, $in_ascii); 
  $output_frames[] = $image_data; 
  $output_times[] = $duration; 

  // TGXf CONTROL -> START -> QRCODE_FPS 
  $frame_data = build_control_frame( 
     $tgxf_control_type["START"]["value"], 
     $tgxf_control_type["START"]["QRCODE_FPS"]["value"], 
     $tgxf_session_qrcode_fps); 
  $image_data = render_frame($frame_data, $tgxf_session_qrcode_version, 
    $mode_ecc_level, $mode_pixel_size, $mode_margin_size, $in_ascii); 
  $output_frames[] = $image_data; 
  $output_times[] = $duration; 

  $fp = fopen($tgxf_session_filepath, 'r'); 
  if($fp != false) { 
    // TGXf DATA (one data frame per loop iteration)
    $max_blocks = ceil($tgxf_session_file_size / $read_bytes);
    for($block_idx = 0; $block_idx < $max_blocks; $block_idx++) {
      // last block an odd size?
      $read_delta = $tgxf_session_file_size - ($block_idx * $read_bytes);
      if($read_delta > 0 && 
        $read_delta < $read_bytes &&
        $block_idx == ($max_blocks - 1)) {
          $read_bytes = $read_delta;
      }
      $raw_data = fread($fp, $read_bytes); 
      $frame_data = build_data_frame($tgxf_session_frame_count, $raw_data, $read_bytes); 
      $image_data = render_frame($frame_data, $tgxf_session_qrcode_version, 
        $mode_ecc_level, $mode_pixel_size, $mode_margin_size, $in_ascii); 
      $output_frames[] = $image_data; 
      $output_times[] = $duration; 
      $tgxf_session_frame_count++; 
      if($tgxf_session_frame_count > 15) 
        $tgxf_session_frame_count = 0; 
    } 
    fclose($fp); 
  } 

  // TGXf CONTROL -> STOP -> COMPLETE 
  $frame_data = build_control_frame( 
    $tgxf_control_type["STOP"]["value"], 
    $tgxf_control_type["STOP"]["COMPLETE"]["value"], 
    $tgxf_session_total_crc32); 
  $image_data = render_frame($frame_data, $tgxf_session_qrcode_version, 
    $mode_ecc_level, $mode_pixel_size, $mode_margin_size, $in_ascii); 
  $output_frames[] = $image_data; 
  $output_times[] = $duration; 

  reset($output_frames);
  reset($output_times);
  if($in_ascii) {
    // ASCII Output
    // http://ascii-table.com/ansi-escape-sequences-vt-100.php
    // See also graphical modes;
    //   http://ascii-table.com/ansi-escape-sequences.php
    print "\033[0;30;47m"; // White on Black
    print "\033[2J";       // Clear screen
    sleep(2);              // Let camera contrast settle
    for($idx = 0; $idx < count($output_frames); $idx++) {
      print "\033[2J";     // Clear screen
      print "\033[0;0H";   // Home top left
      printf('%s', $output_frames[$idx]);
      usleep($output_times[$idx] * 10000);
    }
    sleep(1);
    print "\033[0;37;0m";  // Black on White
    print "\033[2J";
    print "\033[0;0H";

  } else {
    // GRAPHIC Output

    // Initialize and create the final animated GIF 
    $gc = new GifCreator(); 
    $gc->create($output_frames, $output_times, 1); 
    $gifBinary = $gc->getGif(); 

    // Output GIF image
    if(php_sapi_name() != "cli") { 
      header('Content-type: image/gif'); 
      header('Content-Disposition: filename="' . $user_output_file . '"'); 
    } 
    echo $gifBinary; 

  }

?>
